clc
clear all
close all

P1 = round(rand(1,7000));                   % define a logical random sequence
S2 = -2*P1+1;                               % convert to algebraic sequence

S = ones(10,1)*S2;                          % sample them at 10 samples/bit
S1 = reshape(S,1,size(S,1)*size(S,2));

h = spectrum.welch;                         % Create spectrum
HPSD = psd(h,S1,'NFFT',ceil(length(S1)/1),'NormalizedFrequency',false,'CenterDC',true,'Fs',10000);
plot(HPSD)                                  % plot spectrum
xlabel('FREQUENCY (KHz)');
ylabel('POWER  SPECTRAL DENSITY (dB / Hz)');
title('')

m = ceil(length(HPSD.frequencies)/2);

y =  2*cumsum (HPSD.data(m+1:end).*(HPSD.frequencies(m+1:end)-HPSD.frequencies(m:end-1)));
x =  cumsum(HPSD.frequencies(m+1:end)-HPSD.frequencies(m:end-1));

figure
plot(x,y)
xlabel('FREQUENCY  DEVIATION  FROM  CENTRE (Hz)')
ylabel('POWER CONTENT FACTOR')