% This program solves the position with Bancroft's method


P = load('sat_pos.txt');

sat_no = size(P,2);

for t = 1:sat_no
    
    A(t,1) = lorentz(P(:,t),P(:,t));
    B(t,:) = [(P(1:3,t))'  -P(4,t)];
end

U = ones(sat_no,1);
K = inv(B'*B)*B';

c1 = lorentz(K*U,K*U);
c2 = lorentz(K*U,K*A) - 1;
c3 = lorentz(K*A,K*A);


l1 = (-c2 + sqrt(c2^2-4*c1*c3))/(2*c1);
l2 = (-c2 - sqrt(c2^2-4*c1*c3))/(2*c1);

X1 = K*(l1*U + A)*0.5;
X2 = K*(l2*U + A)*0.5;                             

X1
X2

R1 = sqrt(X1(1).*X1(1) + X1(2).*X1(2) + X1(3).*X1(3))
R2 = sqrt(X2(1).*X2(1) + X2(2).*X2(2) + X2(3).*X2(3))