function f=estimate(mdb,obs,v)
clc

disp('Starting Estimation of Parameters');
disp('.');
disp('.');
pause(1);

rs=1;

while ~isempty(obs)
    
    v = 1;
    
    
    % Find time
    tim=obs(1,1);
    
    
    % Select out the data for this instant
    ss      =   find(obs(:,1)==tim);
    A       =   obs(ss,:);
    sat_info =  zeros(size(A,1),4);
    
    
    
    % Calculate prn positions
    for gg=1:size(A,1)
        
        % Check the mdb for nearest ephemeris
        for hh=1:size(mdb,1)
            
                        
            if( (A(gg,2)==mdb(hh,1)) & abs(A(gg,1)-mdb(hh,2))<=7200) 
                
                
                % Get the parameters
                sqrt_a  =   mdb(hh,13);
                ecc     =   mdb(hh,11);
                M0      =   mdb(hh,09);
                del_n   =   mdb(hh,08);
                omega   =   mdb(hh,20);
                toe     =   mdb(hh,14);
                
                if rs==1
                    disp('The required parameters are:')
                    disp(['sqrt_a   (as read from Nav file) = '  num2str(sqrt_a)]);
                    disp(['ecc      (as read from Nav file) = '  num2str(ecc)]);
                    disp(['M0       (as read from Nav file) = '  num2str(M0)]);
                    disp(['del_n    (as read from Nav file) = '  num2str(del_n)]);
                    disp(['omega    (as read from Nav file) = '  num2str(omega)]);
                    disp(['toe =    (as read from Nav file) = '  num2str(toe)]);
                    disp('.');
                    disp('Press a key to continue')
                    disp('.');
                    disp('.');
                    pause
                end
                
                
                mu      =   3.986005e14;
                a       =   sqrt_a^2;
                n0      =   sqrt(mu/(a^3));
                
                t       =   mod(A(gg,1),1e6)-mod(toe,86400);
                
                n       =   n0+del_n;
                M       =   M0+n*t;
                
                               
                E       =   lsqnonlin(@Efun,M,[],[],[],M,ecc);
                
                numer   =   sqrt(1-ecc^2)*sin(E)/(1-ecc*cos(E));
                denom   =   (cos(E)-ecc)/(1-ecc*cos(E));
                nu      =   atan2(numer,denom);
                
                fi      =   nu + omega;
                
                
                if rs==1
                    disp('The derived parameters are:')
                    disp(['mu      =   (Universal)          '  num2str(mu)]);
                    disp(['a       =   sqrt_a^2; =          '  num2str(a)]);
                    disp(['t       =   tk - toe             '  num2str(t)]);
                    disp(['n       =   n0+del_n             '  num2str(n)]);
                    disp(['M       =   M0+n*t               '  num2str(M)]);
                    disp(['E       =   Derived by iteration '  num2str(E)]);
                    disp(['nu      =   Derived from E       '  num2str(nu)]);
                    disp(['fi      =   nu + omega           '  num2str(fi)]);
                    disp('.');
                    disp('Press a key to continue')
                    disp('.');
                    disp('.');
                    pause
                end
                
                
                
                
                
                
                Cus     =   mdb(hh,12);
                Cuc     =   mdb(hh,10);
                Crs     =   mdb(hh,07);
                Crc     =   mdb(hh,19);
                Cis     =   mdb(hh,17);
                Cic     =   mdb(hh,15);
                
                 if rs==1
                    disp('The required parameters are:')
                    disp(['Cus   (as read from Nav file) = '  num2str(Cus)]);
                    disp(['Cuc   (as read from Nav file) = '  num2str(Cuc)]);
                    disp(['Crs   (as read from Nav file) = '  num2str(Crs)]);
                    disp(['Crc   (as read from Nav file) = '  num2str(Crc)]);
                    disp(['Cis   (as read from Nav file) = '  num2str(Cis)]);
                    disp(['Cic = (as read from Nav file) = '  num2str(Cic)]);
                    disp('.');
                    disp('Press a key to continue')
                    disp('.');
                    disp('.');
                    pause
                end
                
                du      =   Cus*sin(2*fi)+Cuc*cos(2*fi); 
                dr      =   Crs*sin(2*fi)+Crc*cos(2*fi); 
                di      =   Cis*sin(2*fi)+Cic*cos(2*fi); 
                
                if rs==1
                    disp('The corrections due to perturbations are:')
                    disp(['du = Cus*sin(2*fi)+Cuc*cos(2*fi) = ' num2str(du)]);
                    disp(['dr = Crs*sin(2*fi)+Crc*cos(2*fi) = ' num2str(dr)]);
                    disp(['di = Cis*sin(2*fi)+Cic*cos(2*fi) = ' num2str(di)]);
                    disp('.');
                    disp('Press a key to continue');
                    disp('.');
                    disp('.');
                    pause
                end
                
                
                i0       =   mdb(hh,18);
                idot     =   mdb(hh,22);
                OMEGA0   =   mdb(hh,16);
                OMEGAdot =   mdb(hh,21);
                OMEGAedot=   7.2921151467e-5;
                
                if rs==1
                    disp('The other required parameters are:')
                    disp(['i0       (as read from Nav file) = '  num2str(i0)]);
                    disp(['idot     (as read from Nav file) = '  num2str(idot)]);
                    disp(['OMEGA    (as read from Nav file) = '  num2str(OMEGA0)]);
                    disp(['OMEGAdot (as read from Nav file) = '  num2str(OMEGAdot)]);
                    disp(['OMEGAedot(Universal)             = '  num2str(OMEGAedot)]);
                    disp('.');
                    disp('Press a key to continue')
                    disp('.');
                    disp('.');
                    pause
                end
                
                              
                u       =   fi+du;
                r       =   a*(1-ecc*cos(E))+dr;
                i       =   i0+di+idot*t;
                
                if rs==1
                    disp('The corrected parameters are:')
                    disp(['u = fi+du               = '  num2str(u)]);
                    disp(['r = a*(1-ecc*cos(E))+dr = '  num2str(r)]);
                    disp(['i = i0+di+idot*t        = '  num2str(i)]);
                    disp('.');
                    disp('Press a key to continue');
                    disp('.');
                    disp('.');
                    pause
                end
                
                
                x1      =   r*cos(u);
                y1      =   r*sin(u);
                
                if rs==1
                    disp('The coordinates on the orbital plane are:')
                    disp(['x1 = r*cos(u) =  ' num2str(x1)]);
                    disp(['y1 = r*sin(u) =  ' num2str(y1)]);
                    disp('.');
                    disp('Press a key to continue');
                    disp('.');
                    disp('.');
                    pause
                end
                
                
                OMEGA   =   OMEGA0 + (OMEGAdot-OMEGAedot)*t - OMEGAedot*toe;
                
                x = x1*cos(OMEGA) - y1*cos(i)*sin(OMEGA);
                y = x1*sin(OMEGA) + y1*cos(i)*cos(OMEGA);
                z = y1*sin(i);
                
                % Enter the position in the sat_info database
                sat_info(gg,1) = x;
                sat_info(gg,2) = y;
                sat_info(gg,3) = z;
                
                if rs==1
                    disp('So, The positions are:')
                    disp('.');
                    disp(['x = x1*cos(OMEGA) - y1*cos(i)*sin(OMEGA)  =    '  num2str(x)]);
                    disp(['y = x1*sin(OMEGA) + y1*cos(i)*cos(OMEGA)  =    '  num2str(y)]);
                    disp(['z = y1*sin(i)                             =    '  num2str(y)]);
                    disp('.')
                    disp('.');
                    disp('Similarly positions for other satellites are determined');
                    disp('.');
                    disp('Press a key to continue')
                    disp('.');
                    disp('.');
                    pause
                
                    rs=rs+1;
                end
                                           
            end
            
        end
        
                
    end
    
    clc
    
      
    % Estimate the Ionospheric parameters
    i_del   =   1.54573*(A(:,4)-A(:,3));    
    
    
    % Correct Ranges and add into sat_info database
    A(:,3)          =   A(:,3)-i_del;
    sat_info(:,4)   =   A(:,3);
    
   
    if v==1
        
        disp('Estimation of Iono delay and correction of Range') ;
        disp('.');
        
        disp(['The time is ' num2str(tim)]);
        
        disp('The measured satellite positions are:  (m)');
        disp(sat_info(:,1:3));
        disp('.')
        pause(4)
        
        disp('The corresponding measured satellite range in L1 is: (m)');
        disp(A(:,3)+i_del)
        disp('.')
        pause(4)
        
        disp('The Ionospheric delay I(L1) in L1 are: 1.54573* [ R(L2) - R(L1) ] in (m)');
        disp(i_del);
        disp('.')
        pause(4)
        
        disp('The corrected values of ranges are: [ R(L1) - I(L1) ] in (m)');
        disp(A(:,3));
        disp('.')
        pause(4)
        
        disp('Similar Range corrections are done for subsequent times');
        disp('Press a key to continue');
        pause
        
        v=v+1;
    end
    
    
    % find position
    find_pos(tim,sat_info)
    
    
    % Remove data for instances already estimated
    obs(ss,:)=[];
    
end