% Klobuchar Function


lat 		= input('Input Latitude in Degrees')
lon 		= input('Input Longitude in Degrees')

t 		= (0:0.25:24);

    
%Initialization ::::::::::::::::::::::::::::::::

% Conversions --

lat   	=   lat/180;                                  % in semicircles
lon   	=   lon/180;                                  % in semicircles
t1     	=   t'*3600;

% Calculations --

phi_m   	=   lat + 0.064 * cos((lon -1.617)*pi);       % Geomagnetic latitude

phi_vect	=   [1;   phi_m;   phi_m^2;   phi_m^3];     

% Reading of Coefficients :::::::::::::::::::::::::::


ion_alfa=   [0.7451D-08  0.1490D-07 -0.5960D-07 -0.1192D-06];
ion_beta=   [0.7987D+05  0.1638D+05 -0.1311D+06 -0.1311D+06];


% Calculation of Iono Delay :::::::::::::::::::::::::

sum_alpha_phi   =   ion_alfa*phi_vect;      % in semicircles
sum_beta_phi    =   ion_beta*phi_vect;      % in semicircles


ion_del         =   [ t1/3600   3e8*((5e-9)+sum_alpha_phi*cos(2*pi*(t1-50400)/sum_beta_phi))]; 

ss		    =   find((ion_del(:,1)<6) | (ion_del(:,1)>22) | ion_del(:,2)<3e8*(5e-9));
ion_del(ss,2)   =   3e8*(5e-9);

ym = max(ion_del(:,2));


figure
plot(ion_del(:,1),ion_del(:,2))
xlabel('LOCAL  TIME (HRS)')
ylabel('EXCESS PATH DUE TO VERTICAL DELAY(M)') 
axis([0  24  0  ym+1])